// Copyright 2003 Adam Megacz, see the COPYING file for licensing [GPL] 

package org.xwt.js; 
import org.xwt.util.*; 
import java.io.*;
import java.util.*;

/** The JavaScript Math object */
class Math extends JS.Obj {
    public static Math singleton = new Math();

    private static final JS.Callable ceil = new JS.Callable() { public Object call(JS.Array args) {
        return new Long((long)java.lang.Math.ceil(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable floor = new JS.Callable() { public Object call(JS.Array args) {
        return new Long((long)java.lang.Math.floor(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable round = new JS.Callable() { public Object call(JS.Array args) {
        return new Long((long)java.lang.Math.round(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable min = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.min(JS.toNumber(args.elementAt(0)).doubleValue(),
            JS.toNumber(args.elementAt(1)).doubleValue())); } };

    private static final JS.Callable max = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.max(JS.toNumber(args.elementAt(0)).doubleValue(),
            JS.toNumber(args.elementAt(1)).doubleValue())); } };

    private static final JS.Callable pow = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.pow(JS.toNumber(args.elementAt(0)).doubleValue(),
            JS.toNumber(args.elementAt(1)).doubleValue())); } };

    private static final JS.Callable atan2 = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.atan2(JS.toNumber(args.elementAt(0)).doubleValue(),
            JS.toNumber(args.elementAt(1)).doubleValue())); } };

    private static final JS.Callable abs = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.abs(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable sin = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.sin(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable cos = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.cos(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable tan = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.tan(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable asin = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.asin(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable acos = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.acos(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable atan = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.atan(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable sqrt = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.sqrt(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable exp = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.exp(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable log = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.log(JS.toNumber(args.elementAt(0)).doubleValue())); } };

    private static final JS.Callable random = new JS.Callable() { public Object call(JS.Array args) {
        return new Double(java.lang.Math.random()); } };

    private static final Double E       = new Double(java.lang.Math.E);
    private static final Double PI      = new Double(java.lang.Math.PI);
    private static final Double LN10    = new Double(java.lang.Math.log(10));
    private static final Double LN2     = new Double(java.lang.Math.log(2));
    private static final Double LOG10E  = new Double(1/java.lang.Math.log(10));
    private static final Double LOG2E   = new Double(1/java.lang.Math.log(2));
    private static final Double SQRT1_2 = new Double(1/java.lang.Math.sqrt(2));
    private static final Double SQRT2   = new Double(java.lang.Math.sqrt(2));

    Math() {
        put("abs", abs);
        put("acos", acos);
        put("asin", asin);
        put("atan", atan);
        put("atan2", atan2);
        put("ceil", ceil);
        put("cos", cos);
        put("exp", exp);
        put("floor", floor);
        put("log", log);
        put("max", max);
        put("min", min);
        put("pow", pow);
        put("random", random);
        put("round",round);
        put("sin", sin);
        put("sqrt", sqrt);
        put("tan", tan);

        put("E", E);
        put("LN10", LN10);
        put("LN2", LN2);
        put("LOG10E", LOG10E);
        put("LOG2E", LOG2E);
        put("PI", PI);
        put("SQRT1_2", SQRT1_2);
        put("SQRT2", SQRT2);

        setSeal(true);
    }
}
